module Aufgabe_01 exposing (..)

import Html exposing (text, ul, li)
import List exposing (map)



type alias Amount =
    Int


type alias Money =
    List Int


input : Amount
input =
    4711


euro : Money
euro =
    [ 50000
    , 20000
    , 10000
    , 5000
    , 2000
    , 1000
    , 500
    , 200
    , 100
    , 50
    , 20
    , 10
    , 2
    , 1
    ]


change : Amount -> Money -> Result String Money
change amount currency =
    if amount == 0 then
        Ok []

    else
        case currency of
            head :: tail ->
                if head <= amount then
                    case change (amount - head) currency of
                        Err message ->
                            Err message

                        Ok rest ->
                            Ok (head :: rest)

                else
                    change amount tail

            [] ->
                Err "kein Wechselgeld"


main = case change input euro of
            Ok changed ->
                 ul [] (map (\x -> li [] [(text (String.fromInt x))]) changed)

            Err message ->
                text message
