module Pflichtuebung_01.Date exposing (..)
module Date exposing (..)

type alias Day =
    Int

type alias Month =
    Int

type alias Year =
    Int

type alias Date =
    ( Day, Month, Year )


-- 1 Punkt:
year : Date -> Year
year (_, _, c) = c
month : Date -> Month
month (_, b, _) = b
day : Date -> Day
day (a, _, _) = a

-- 1 Punkt:
lt : Date -> Date -> Bool
lt date1 date2 =
    let (d1, m1, y1) = date1
        (d2, m2, y2) = date2
    in y1 < y2 || (y1 == y2 && (m1 < m2 || (m1 == m2 && d1 < d2)))
eq : Date -> Date -> Bool
eq date1 date2 =
    let (d1, m1, y1) = date1
        (d2, m2, y2) = date2
    in y1 == y2 && m1 == m2 && d1 == d2
gt : Date -> Date -> Bool
gt date1 date2 =
    let (d1, m1, y1) = date1
        (d2, m2, y2) = date2
    in y1 > y2 || (y1 == y2 && (m1 > m2 || (m1 == m2 && d1 > d2)))

-- 1 Punkt:
toString : Date -> String
toString (a,b,c) = (if a < 10 then "0" ++ String.fromInt(a) else String.fromInt(a)) ++ "."
                    ++ (if b < 10 then "0" ++ String.fromInt(b) else String.fromInt(b)) ++ "."
                    ++ (if c < 10 then  "000" ++ String.fromInt(c)
                    else if c < 100 then  "00" ++ String.fromInt(c)
                    else if   c < 1000 then  "0" ++ String.fromInt(c)
                    else String.fromInt(c))


-- https://web.archive.org/web/20170507133619/https://alcor.concordia.ca/~gpkatch/gdate-algorithm.html

convertDateToDayNumber : Date -> Int
convertDateToDayNumber (a, b, c) =
    let m = (modBy 12 (b + 9))
        y = c - m // 10
    in 365 * y + y // 4 - y // 100 + y // 400 + (m * 306 + 5) // 10 + ( a - 1 )

convertDayNumberToDate : Int -> Date
convertDayNumberToDate g =
    let y = (10000 * g + 14780) // 3652425
        ddd = g - (365 * y + y // 4 - y // 100 + y // 400)
    in
        if (ddd < 0) then
            let y2 = y - 1 -- y = y2
                ddd2 = g - (365 * y2 + y2 // 4 - y2 // 100 + y2 // 400)  -- ddd = ddd2
                mi = (100 * ddd2 + 52) // 3060
                mm = (modBy (12) (mi + 2)) + 1
                y3 = y2 + (mi + 2) // 12  -- y = y3
                dd = ddd2 - (mi * 306 + 5) // 10 + 1
            in (dd, mm, y3)
        else
            let mi = (100 * ddd + 52) // 3060
                mm = (modBy (12) (mi + 2)) + 1
                y2 = y + (mi + 2) // 12  -- y = y2
                dd = ddd - (mi * 306 + 5) // 10 + 1
            in (dd, mm, y2)

-- 1 Punkt:
leapyear : Year -> Bool
leapyear y = ((modBy 4 y == 0) && (modBy 100 y /= 0)) || (modBy 400 y == 0)


-- 2 Punkte:
next : Date -> Date
next date = convertDayNumberToDate ((convertDateToDayNumber date) + 1)

-- 2 Punkte:
prev : Date -> Date
prev date = convertDayNumberToDate ((convertDateToDayNumber date) - 1)

-- 2 Punkte:
sub : Date -> Date -> Int
sub date1 date2 = convertDateToDayNumber date1 - convertDateToDayNumber date2

